# Record Class MLink

java.lang.Object
java.lang.Record
com.io7m.montarre.api.MLink

Record Components:
  `role` - The link role
  `target` - The target

All Implemented Interfaces:
  `Comparable<MLink>`

public record MLink(MLinkRole role, URI target) extends Record implements Comparable<MLink>
A link.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MLink(MLinkRole role, URI target)`
  A link.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(MLink other)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `MLinkRole`
  `role()`
  Returns the value of the `role` record component.
  `URI`
  `target()`
  Returns the value of the `target` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### MLink

    public MLink(MLinkRole role, URI target)
    A link.
    Parameters:
      `role` - The link role
      `target` - The target

- ## Method Details

  - ### compareTo

    public int compareTo(MLink other)
    Specified by:
      `compareTo` in interface `Comparable<MLink>`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### role

    public MLinkRole role()
    Returns the value of the `role` record component.
    Returns:
      the value of the `role` record component

  - ### target

    public URI target()
    Returns the value of the `target` record component.
    Returns:
      the value of the `target` record component